/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
import { IValidateInitialize } from "@appsensorlike/appsensorlike/core/core.js";
import { ActionRequest, ActionResponse } from "../appsensor-websocket.js";
import { ClientRequestArgs } from "http";
import WebSocket from "ws";
declare class WebSocketClientConfig implements IValidateInitialize {
    static DEFAULT_RETRY_INTERVAL: number;
    address: string | URL;
    options?: WebSocket.ClientOptions | ClientRequestArgs | undefined;
    reconnectOnConnectionLost?: boolean;
    reconnectRetryInterval?: number;
    checkValidInitialize(): void;
}
declare class AppSensorWebSocketClient {
    protected socket: WebSocket | null;
    protected myUUID: string;
    protected reconnectAddress: string | URL;
    protected reconnectConfig: WebSocketClientConfig;
    protected reconnectTimer: NodeJS.Timer | null;
    constructor(config: WebSocketClientConfig);
    protected connect(address: string | URL, options?: WebSocket.ClientOptions | ClientRequestArgs): void;
    protected onOpen(): void;
    protected onError(error: Error): void;
    protected onClose(code: number, reason: Buffer): void;
    protected reconnect(): void;
    onMessage(data: WebSocket.RawData, isBinary: boolean): void;
    protected onServerResponse(response: ActionResponse): void;
    protected static createRequest(actionName: string, parameters?: {
        [propertyName: string]: string | Object;
    }): ActionRequest;
    protected sendRequest(request: ActionRequest, cb: (err?: Error) => void): Promise<void>;
    closeSocket(): Promise<void>;
}
export { AppSensorWebSocketClient, WebSocketClientConfig };
